﻿Procedure  Tri (ox1, oy1, ox2, oy2, ox3, oy3, clr)

; '    
; '   
; '             /
; '        d1 /  |
; '         /    |
; '         \    |
; '          \   |d3
; '        d2 \  |
; '            \ |
; '             \|
; 
; 'This implementation of the filled triangle routine is
; 'the the fast floating point version.
; 'Look at the 2 loops below. It first calculate the derivatives and uses DDA
; 'to get LX!,RX!.  It works because of the fact that multiplication is just
; 'repeated addition.

; Dim x1 As INTEGER, y1 As INTEGER        'These are the coodinates of
; Dim x2 As INTEGER, y2 As INTEGER        'the triangle
; Dim x3 As INTEGER, y3 As INTEGER
; 
; Dim dx1 As INTEGER, dy1 As INTEGER      'used for interpolation
; Dim dx2 As INTEGER, dy2 As INTEGER      'dx1 is the difference in x1
; Dim dx3 As INTEGER, dy3 As INTEGER      'and so forth
;                                                     
; Dim delta1!, delta2!, delta3!           'These are used for incrementing the
;                                         'inverse-slope of the line that
;                                         'composes the triangle

x1 = ox1 ;           'simulate the BYVAL keyword by storing
y1 = oy1 ;           'the vertices in temporary variables

x2 = ox2
y2 = oy2

x3 = ox3
y3 = oy3

If y2 < y1; THEN         'sort vertices is not in-order
   Swap y1, y2
   Swap x1, x2
  EndIf
  
If y3 < y1; THEN
    Swap y3, y1
    Swap x3, x1
EndIf

If y3 < y2; THEN
    Swap y3, y2
    Swap x3, x2
EndIf

dx1 = x2 - x1;               'calculate difference in X
dy1 = y2 - y1;               'difference in Y
If dy1 <> 0; THEN            'check for divide by zero
    delta1.f = dx1 / dy1 ;    'interpolate Top-Left side
Else
    delta1.f = 0
EndIf

dx2 = x3 - x2;               'Lower left side
dy2 = y3 - y2
If dy2 <> 0; THEN
    delta2.f = dx2 / dy2
Else
    delta2.f = 0
EndIf


dx3 = x1 - x3;               'Right side
dy3 = y1 - y3
If dy3 <> 0; THEN
    delta3.f = dx3 / dy3
Else
    delta3.f = 0
EndIf


;'Flat bottom
;'Tup part of triangle
;''code: x1 + (y - y1) * delta1!
;'is changed to:
;'Lx! = x1
;'For y=y1 to y2
;    Lx! = Lx! + delta1!     '(y - y1) * Delta1! = (Lx!+ Delta1!) * NumberOfLoops
;'nexft y

Lx.f = x1
Rx.f = x1

For y = y1 To y2 - 1
    LineXY (Lx, y,Rx, y,clr)
    Lx = Lx + delta1;             'increment derivatives
    Rx = Rx + delta3
Next y

;'Flat top
;'Lower part of triangle

Lx = x2
For y = y2 To y3
    LineXY(Lx, y,Rx, y, clr)
    Lx = Lx + delta2
    Rx = Rx + delta3
Next y


EndProcedure;End SUB


  If OpenWindow(0, 0, 0, 640, 480, "trifill", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    CanvasGadget(0, 0, 0, 640, 480)
    a=0
    r=200
    c1.f=#PI/180
    Repeat
      Event = WindowEvent()

      StartDrawing(CanvasOutput(0))
      Box(0,0,640,480,0)
      x0=Int(320+r*Cos(a*c1))
      y0=Int(240+r*Sin(a*c1))
      
      x1=Int(320+r*Cos((120+a)*c1))
      y1=Int(240+r*Sin((120+a)*c1))
      
      x2=Int(320+r*Cos((240+a)*c1))
      y2=Int(240+r*Sin((240+a)*c1))
      
      tri(x0,y0,x1,y1,x2,y2,RGB(0,250,0))
      StopDrawing()
      
      a=(a+1)%360
    Until Event = #PB_Event_CloseWindow
  EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 130
; FirstLine = 98
; Folding = -
; EnableUnicode
; EnableXP
; Executable = trifill.exe